/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.cg.util;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;

import blanco.cg.BlancoCgSupportedLang;
import blanco.commons.util.BlancoJavaSourceUtil;
import blanco.commons.util.BlancoPhpSourceUtil;
import blanco.commons.util.BlancoVbSourceUtil;

/**
 * blancoCg̃\[XR[h֘A[eBeBłB
 * 
 * ̃NX̓vO~O𒴂ėp܂B
 * 
 * @author IGA Tosiki
 */
public class BlancoCgSourceUtil {
    /**
     * ^ꂽ\[XR[hƂďo͂̂ƂăGXP[v܂B
     * 
     * /obNXbṼGXP[vщsR[h̃GXP[vs܂B<br>
     * ȊȌ͍s܂BƂ΃CWFNVUȂǂւ̑ϐ́Ã\bh͈܂B
     * 
     * @param targetLang
     *            o͑Ώۂ̃vO~OB
     * @param originalString
     *            ͕B
     * @return GXP[vsꂽ̕B
     */
    public static String escapeStringAsSource(final int targetLang,
            final String originalString) {
        switch (targetLang) {
        case BlancoCgSupportedLang.JAVA:
        case BlancoCgSupportedLang.CS:
        case BlancoCgSupportedLang.JS:
            return BlancoJavaSourceUtil
                    .escapeStringAsJavaSource(originalString);
        case BlancoCgSupportedLang.VB:
            return BlancoVbSourceUtil.escapeStringAsVbSource(originalString);
        case BlancoCgSupportedLang.PHP:
        case BlancoCgSupportedLang.RUBY: // TODO Ó̊mF
        case BlancoCgSupportedLang.PYTHON: // TODO Ó̊mF
            return BlancoPhpSourceUtil.escapeStringAsPhpSource(originalString);
        case BlancoCgSupportedLang.DELPHI: // TODO Ó̊mF
            return escapeStringAsDelphiSource(originalString);
        default:
            throw new IllegalArgumentException(
                    "BlancoCgSourceUtil.escapeAsSourceString ɃT|[gȂ("
                            + targetLang + ")Ƃė^܂B");
        }
    }

    /**
     * ^ꂽhLgƂĈƂł悤 GXP[v܂B
     * 
     * JavaDocƂăGXP[vs܂B HTMLƂẴGXP[vƓ̏s܂BhGXP[v܂B
     * 
     * @param targetLang
     *            o͑Ώۂ̃vO~OB
     * @param originalString
     *            ͕
     * @return GXP[vsꂽ̕B
     */
    public static final String escapeStringAsLangDoc(final int targetLang,
            final String originalString) {
        switch (targetLang) {
        case BlancoCgSupportedLang.JAVA:
        case BlancoCgSupportedLang.CS:
        case BlancoCgSupportedLang.JS:
        case BlancoCgSupportedLang.VB:
        case BlancoCgSupportedLang.PHP:
        case BlancoCgSupportedLang.RUBY:
        case BlancoCgSupportedLang.PYTHON:
        case BlancoCgSupportedLang.DELPHI:
            return BlancoJavaSourceUtil.escapeStringAsJavaDoc(originalString);
        default:
            throw new IllegalArgumentException(
                    "BlancoCgSourceUtil.escapeStringAsLangDoc ɃT|[gȂ("
                            + targetLang + ")Ƃė^܂B");
        }
    }
    
    /**
     * ^ꂽDelphi\[XR[hƂďo͂邽߂̃GXP[v܂B
     * 
     * /obNXbṼGXP[vщsR[h̃GXP[vs܂B<br>
     * ȊȌ͍s܂BƂ΃CWFNVUȂǂւ̑ϐ́Ã\bh͈܂B
     * 
     * @param originalString
     *            ͕
     * @return GXP[vsꂽ̕
     */
    private static final String escapeStringAsDelphiSource(
            final String originalString) {
        if (originalString == null) {
            throw new IllegalArgumentException(
                    "BlancoCgSourceUtil.escapeStringAsDelphiSourceœ͈ᔽB̃\bhnullp[^Ƃė^܂BnullȊO̒l͂ĂB");
        }

        final StringReader reader = new StringReader(originalString);
        final StringWriter writer = new StringWriter();
        try {
            for (;;) {
                final int iRead = reader.read();
                if (iRead < 0) {
                    break;
                }
                switch (iRead) {
                // Delphił́AobNXbVGXP[vKv܂B
//                case '\\':
//                    writer.write("\\");
//                    break;
                case '\n':
                    writer.write("\\n");
                    break;
                case '\'':
                    writer.write("\'\'");
                    break;
                default:
                    writer.write((char) iRead);
                    break;
                }
            }
            writer.flush();
        } catch (IOException e) {
            // ɓĂ邱Ƃ́A肦܂B
            e.printStackTrace();
        }
        return writer.toString();
    }

}